( function( $ ) {
$( document ).ready(function() {
    //$('#horiz-menu').prepend('<div id="bg-one"></div><div id="bg-two"></div><div id="bg-three"></div><div id="bg-four"></div>');
    select_page("channels","item_channels","");
});
} )( jQuery );

      function sanitize_string(str) {
         var sanitized=str.toLowerCase().replace(/[^a-zA-Z0-9-_\.]/g,'');
         console.log("sanitize_string/str="+str+"/sanitized="+sanitized);
         return sanitized;
      }

	  var waitingDialog = waitingDialog || (function ($) {
		'use strict';

		// Creating modal dialog's DOM
		var $dialog = $(
			'<div class="modal fade" data-backdrop="static" data-keyboard="false" tabindex="-1" role="dialog" aria-hidden="true" style="padding-top:15%; overflow-y:visible;">' +
			'<div class="modal-dialog modal-m">' +
			'<div class="modal-content">' +
				'<div class="modal-header"><h3 style="margin:0;"></h3></div>' +
				'<div class="modal-body">' +
					'<div class="progress progress-striped active" style="margin-bottom:0;"><div class="progress-bar" style="width: 100%"></div></div>' +
				'</div>' +
			'</div></div></div>');

		return {
			/**
			 * Opens our dialog
			 * @param message Custom message
			 * @param options Custom options:
			 * 				  options.dialogSize - bootstrap postfix for dialog size, e.g. "sm", "m";
			 * 				  options.progressType - bootstrap postfix for progress bar type, e.g. "success", "warning".
			 */
			show: function (message, options) {
				// Assigning defaults
				if (typeof options === 'undefined') {
					options = {};
				}
				if (typeof message === 'undefined') {
					message = 'Loading';
				}
				var settings = $.extend({
					dialogSize: 'm',
					progressType: '',
					onHide: null // This callback runs after the dialog was hidden
				}, options);

				// Configuring dialog
				$dialog.find('.modal-dialog').attr('class', 'modal-dialog').addClass('modal-' + settings.dialogSize);
				$dialog.find('.progress-bar').attr('class', 'progress-bar');
				if (settings.progressType) {
					$dialog.find('.progress-bar').addClass('progress-bar-' + settings.progressType);
				}
				$dialog.find('h3').text(message);
				// Adding callbacks
				if (typeof settings.onHide === 'function') {
					$dialog.off('hidden.bs.modal').on('hidden.bs.modal', function (e) {
						settings.onHide.call($dialog);
					});
				}
				// Opening dialog
				$dialog.modal();
			},
			/**
			 * Closes dialog
			 */
			hide: function () {
				$dialog.modal('hide');
			}
		};

	  })(jQuery);

      function registerRowButtonHandlers(elem,urltype,tdHtml) {
    	console.log("registerRowButtonHandlers("+elem+","+urltype+")"+","+tdHtml);
		var element=$(elem);
    	console.log("registerRowButtonHandlers/elem=",elem);
		element.find(".addRowBtn").on("click",function(ev) {
			ev.preventDefault();
			var tBody=$(this).parents(".tbody").first();
			tBody.append(tdHtml);
			var newRow=tBody.children(".row").last();
			console.log("addRowBtn/tdHtml="+tdHtml+"/tBody=",tBody,"newRow=",newRow);
			registerRowButtonHandlers(newRow,urltype,tdHtml);
		});
		
		element.find(".delRowBtn").on("click",function(ev) {
			ev.preventDefault();
			var tBody=$(this).parents(".tbody").first();
			//console.log(tBody);
			var tRow=$(this).parents(".row").first();
			//console.log(tRow);
			var delRow=true;
			if (urltype=="schedule") {
				var scheduleId=tRow.find("[name=uuid]").first();
				if (scheduleId.val()!="") {
					scheduleId.after($('<input type="hidden" name="delete" value="yes">'));
					tRow.css("background", "red").addClass("disabled");
					tRow.find("input,select,.glyphicon-calendar,a").addClass("disabled").off("click").removeAttr("href");
					delRow=false;
				}
			}
			if (delRow)
				tRow.remove();
			if (tBody.children().length==0) {
				tBody.append(tdHtml);
				var newRow=tBody.children(".row").last();
				registerRowButtonHandlers(newRow,urltype,tdHtml);
			}
		});    
		
		element.find("[name=video_res]").on("change",function() {
			var parent=$(this).parents(".row").first();
			var video_res=parent.find("[name=video_res]");
			
			parent.find(".customRes")
				  .css("display",video_res.val()=="custom" ? "block" : "none");
			parent.find("[name=video_res_x],[name=video_res_y]")
				  .attr("disabled",video_res.val()!="custom");
					
		});
		element.find("[name=video_res]").trigger("change");
		
		element.find("[name=video_kbps]").on("change",function() {
			var parent=$(this).parents(".row").first();
			var video_kbps=parent.find("[name=video_kbps]");
			
			parent.find(".customKbps")
				  .css("display",video_kbps.val()=="custom" ? "block" : "none");
			parent.find("[name=video_kbps_custom]")
				  .attr("disabled",video_kbps.val()!="custom");
					
		});
		element.find("[name=video_kbps]").trigger("change");
		
		var deviceElems=element.find("[name=device]");
		deviceElems.on("change",function() {
			var device=$(this);
			var deviceVal=device.val() ? device.val() : "";
			if (deviceVal!="") {
				var parent=device.parents(".row").first();
				var format=parent.find("[name=format]");
				
				if (deviceVal=="off") {
					format.prop("disabled",true).addClass("disabled");
				} else {
					format.prop("disabled",false).removeClass("disabled");
					var formatsId=format.attr("data-mode")=="output" ? "#decklinkOutFormatsList" : "#decklinkFormatsList";
					var formatsList=$(formatsId+"-"+sanitize_string(deviceVal));
					if (formatsList.length)
						format.html(formatsList.html());
				}
			}
		}); //.trigger("change");
		
		deviceElems.each(function() {
			var device=$(this);
			if (device.val()=="off")
				device.trigger("change")
		});
		
		if (urltype=="pull" || urltype=="deck") {
			// ,td.fieldButtons .addRowBtn
			element.find("[name=container]").attr("disabled",urltype!="push").css("display","none");
			
			element.find("a.liveSwitchUrl").on("click",liveSwitchClick);
			
			if (urltype=="pull") {
				element.find("[name=url]").on("keypress",function() {
					var url=$(this);
					var parent=url.parents(".row").first();
					
					var is_rtsp = (url.substr(0,4) == "rtsp");
					var rtsp_transport=parent.find("[name=rtsp_transport]");
					rtsp_transport.css("display", is_rtsp)
								 .attr("disabled",is_rtsp);
					
				}).trigger("keypress");
			}
			
			if (urltype=="deck") {
				element.find("[name=audio_kbps],[name=video_kbps]").each(function(index,selec) {
					var control=$(selec);
					control.find("option[value=off]").attr("disabled",true);
					if (!control.val() || control.val()=="off") {
						control[0].selectedIndex=1;
					}
				});
				element.find("[name=stream_live]").prop("checked",true).prop("disabled",true);
			}
		} else
		if (urltype=="push") {
			element.find("[name=container]").each(function(index,cont) {
				var container=$(cont);
				container.off("change");
				container.on("change",function(ev){
					var container=$(this);
					var parent=container.parents(".row").first();
					var inputurl=parent.find("input[name=url]");
					if (container.val()=="flv") {
						inputurl.attr("pattern","^rtmp://.*$");
					} else
					if (container.val()=="mpegts") {
						inputurl.attr("pattern","^udp://.*$");
					}
				});
				container.trigger("change");
			});
			
			element.find("li.live_stream").css("display","none");
			element.find("[name=stream_live]").attr("checked",true);
		} else
		if (urltype=="schedule") {
			var pickers=element.find(".recordSchedulestartPicker,.recordSchedulestopPicker");
			pickers.each(function() {
				var picker=$(this);
				var dtValue=picker.find("input").attr("data-value");
				console.log("picker=",picker,"dtValue=",dtValue);
				picker.datetimepicker({
					viewMode: "days",
					format: "YYYY-MM-DDTHH:mm:ssZ",//"YYYY-MM-DD HH:mm:ss", //"dddd, MMMM Do YYYY, h:mm:ss a",
			        extraFormats: [moment.ISO_8601],
					showClear: true,
					showClose: true,
					toolbarPlacement: "top",
					defaultDate: dtValue,
					sideBySide: true
				});
			});
		}
		
		if (urltype=="pull" || urltype=="deck" || urltype=="push") {
			element.find(".btn-info,.popout a.close").on("click",popoutVideoSettings);
			
			var triggerElems=element.find("[name=video_kbps],[name=video_res],[name=video_res_x],[name=video_res_y],[name=deinterlace],[name=video_profile],[name=video_level],[name=video_preset],[name=video_keyint],[name=video_goptype]");
			triggerElems.on("change",function() {
				var elem=$(this);
				var parent=elem.parents("div.row").first();
				var video_elems=parent.find("[name=video_res],[name=video_profile],[name=video_level],[name=video_preset],[name=deinterlace],[name=video_keyint],[name=video_goptype]");
				var video_kbps=parent.find("[name=video_kbps]");
				if (video_kbps.val()=="off")
					parent.find("[name=video_res]").val("off");
				video_elems.attr("disabled",video_kbps.val()=="off");
				console.log("video_kbps/video_res.attr , disabled="+(elem.val()=="off" ? "true" : "false"));
			
				updateVideoInfo(parent);
			});
			triggerElems.trigger("change");
			
			var trChilds=element.find(".tbody>.row");
			var passCandidates= trChilds.length>0 ? trChilds : element;
		
			passCandidates.each(function() {
				var trRow=$(this);
				updateVideoInfo(trRow);
			});
		}
		
	  }
    
      function serializeTranscodeTable(table,fieldSelector,format) {
    	var tBody=$(table).find(".tbody").first();
    	var rows=[];
    	tBody.children(".row").each(function() {
    		var row={};
    		//console.log("tBody",tBody);
    		$(this).children("div").each(function() {
    			var childTd=$(this);
    			if (childTd.hasClass(fieldSelector)) {
    				row.url=$(this).text();
    			} else {
    				var tdInputs=childTd.find("select[name],input[name]");
    				tdInputs.each(function() {
    					var childInput=$(this);
    					var val;
    					if (childInput.attr("type")=="radio" || childInput.attr("type")=="checkbox") {
    						val=childInput.prop("checked") ? "on" : "off";
    					} else {
    						val=childInput.val();
    					}
    					row[childInput.attr("name")]=val;
    				});
    			}
    			//console.log("childTd",childTd);
    		});
    		rows.push(row);
    		console.log("rows",rows);
    	});
    	
    	if (format==undefined) {
    		return rows;
    	} else
    	if (format=="json") {
    		console.log("rowsJSON",JSON.stringify(rows));
    		return JSON.stringify(rows);
    	}
      }

function select_page(page,menuitem,id)
{
    var url='ajax_form.php?form='+page;
    
    if (id!="") {
      //identity=$('<div/>').text(id).html();
      url += "&id="+id;
    }
    
	waitingDialog.show();
    $.ajax({
	  url: url,
	  cache: false
	}).done(function( html ) {
		$('#zbody').html( html );
	}).always(function() {
		waitingDialog.hide();
	});
    
    $('li', $('#cssmenu')).each(function(i,elm) {
      if (elm.id==menuitem) {
        elm.className="active";
      } else {
        elm.className="";
      }
    });
    
    check_needs_reload();
    
    return false;
}

function channel_command(href,chan_id,cmd) {
    var url='command.php?channel='+chan_id+'&'+cmd;
    $.getJSON(url, function(cmd_object){
        if (cmd_object.command=="state") {
            if (cmd_object.value=="start") {
              imgstate="start";
              cmdstate="stop";
            } else {
              imgstate="stop";
              cmdstate="start";
            }
            img_url='images/'+imgstate+'_button.png';
            
            $(href).attr("onclick","return channel_command(this,\""+chan_id+"\",\"state="+cmdstate+"\");");
            $(href).html('<img src="'+img_url+'" title="Click to '+cmdstate+' channel">');
            //$(href).children(":image").src=img_url;
            //$(href).children(":image").title="Click to "+cmdstate+" channel";
        } else
        if (cmd_object.command.substr(0,7)=="record_") {
        	$("#channelCommandError").text(cmd_object.error);
        }
        
        check_needs_reload();
    });
    
    return false;
}

function check_needs_reload() {
	$.ajax({
	  url: "/command.php?command=needs_reload",
	  cache: false
	}).done(function( html ) {
		$( ".restart_message" ).html( html );
	  });
}

function reload_service_command() {
	$.ajax({
	  url: "/command.php?command=reload_service",
	  cache: false
	}).done(function( html ) {
		$( ".restart_message" ).html( html );
	  });
}

function restart_service_command() {
	$.ajax({
	  url: "/command.php?command=restart_service",
	  cache: false
	}).done(function( html ) {
		$( ".restart_message" ).html( html );
	});
}

function update_dvss_command() {
	$.ajax({
	  url: "/command.php?command=update_service",
	  cache: false
	}).done(function( html ) {
		$( ".update_message" ).html( html );
	  });
}

function update_Height() {
	$("#zouter").animate({
		height:$("#zbody").height()
	},600);
}

function toggleFormField(checkbox,element) {
	if ($(checkbox).is(':checked')) {
	  $(element).removeAttr('disabled');
	} else {
	  $(element).attr('disabled', true);
	}
}


