<?php

function getcommandsdir()
{
    $commandsdir="/tmp/nginx_commands";
    if (!is_dir($commandsdir)) {
      mkdir($commandsdir);
    }
    return $commandsdir;
}

function getlicensedir() {
	return "/opt/nginx-dvss/settings/license";
}

function nginx_reload($json,$markonly=true) {
	$restart_file=getcommandsdir()."/restart.json";
	if ($markonly) {
		file_put_contents($restart_file,$json);
	} else {
		if (file_exists($restart_file)) {
			$json=file_get_contents($restart_file);
			unlink($restart_file);
		}
	
		$command_file=getcommandsdir()."/commands.json";
		if (!$markonly) {
			file_put_contents($command_file,$json);
		}
	}
}

	header( 'Expires: Sat, 26 Jul 1997 05:00:00 GMT' ); 
	header( 'Last-Modified: ' . gmdate( 'D, d M Y H:i:s' ) . ' GMT' ); 
	header( 'Cache-Control: no-store, no-cache, must-revalidate' ); 
	header( 'Cache-Control: post-check=0, pre-check=0', false ); 
	header( 'Pragma: no-cache' );

echo('<html>
<head>
  <title>License Management</title>
  <style>
    body {
      margin: 0;
    }
    
	.loader {
		display: block;
		position: fixed;
		width: 100%;
		height: 100%;
		padding: 30px;
		background-color: rgba(66,125,125,0.6);
		margin: 0;
	}
	
	.progress-circle {
		position: relative;
		text-align: center;
		top: 5px;
		left: 5px;
		width: 100px;
		height: 100px;
		border-radius: 100%;
		background-color: #E6F4F7;
	}

	.active-border {
		position: absolute;
		text-align: center;
		width: 110px;
		height: 110px;
		top: 50%;
		left: 50%;
		margin-left: -55px;
		margin-top: -55px;		
		border-radius: 100%;

		background-color:#39B4CC;
		background-image:
		    linear-gradient(91deg, transparent 50%, #A2ECFB 50%),
		    linear-gradient(90deg, #A2ECFB 50%, transparent 50%);
		
	}
  </style>
  <script src="js/jquery-1.10.2.min.js"></script>
</head>
<body>');

//if (!array_key_exists('licensekey',$_FILES))
if ($_SERVER['REQUEST_METHOD'] == 'GET')
{
echo('<div class="loader">
<br><br><br>
<strong>Your DVS-200 license is being verified, please refresh this page in 60 seconds, if verification was successful the DVS-200 web interface will load.<br>
If the DVS-200 web interface does not load please ensure you have uploaded a valid licence key and this DVS-200 can access the internet.<br>
If you have made hardware changes this may have affected the licence status, please contact your reseller for support.</strong><br>
<br><br>
<form enctype="multipart/form-data" action="index.php" method="POST">
&nbsp;&nbsp;&nbsp;Upload license key: <input name="licensekey" type="file" accept=".lic" /><br><br><br>
&nbsp;&nbsp;&nbsp;<input name="delete_license" type="checkbox" value="on" />&nbsp;&nbsp;Delete existing license key and switch to Free mode
<br><br>
<input type="submit" value="Upload" />
</form>
</div>');
} else
if ($_SERVER['REQUEST_METHOD'] == 'POST') {
	if (array_key_exists("delete_license",$_POST) && $_POST["delete_license"]=="on") {
		// Delete existing license
		$lic_file=getlicensedir()."/dvss.lic";
		unlink($lic_file);
		nginx_reload('{"command":"restart","state":"delicensing"}',false);
		
		echo('	<div class="loader">
		<br><br>
			&nbsp;&nbsp;&nbsp;<h2><strong>License key was deleted</strong></h2><br>
			Any existing license key was deleted, and this unit switched to FREE Mode<br>
			<a href="/license/">Goto License Page</a> and apply a valid license key to enable Pro features
		<br><br>
  </div>');
	} else
	if (!array_key_exists('licensekey',$_FILES)) {
		// Give Error Message that license doesn't exist
echo('	<div class="loader">
		<br><br>
			&nbsp;&nbsp;&nbsp;<h2><strong>License key is missing.</strong></h2><br>
			Could not apply a license as none was provided<br>
			<a href="/license/">Goto License Page</a> and apply a valid license key to enable Pro features
		<br><br>
  </div>');
	} else {
		$lic_key=file_get_contents($_FILES['licensekey']['tmp_name']);
		$lic_dir=getlicensedir();
		if (!is_dir($lic_dir))
			mkdir($lic_dir);
		if (file_put_contents($lic_dir."/dvss.lic",$lic_key)) {
			$lic_file=getlicensedir()."/dvss.lic";
			nginx_reload('{"command":"restart","state":"delicensing"}',false);
		}
		echo('<div class="loader">
  <div>
		<br><br>
			&nbsp;&nbsp;&nbsp;<strong>License key has been applied.</strong><br>
			If the key is valid for this unit , then the unit features should get unlocked within a minute<br>
			Kindly reload this page after a minute to check
		<br><br>
  </div>
  <div class="active-border">
        <div class="progress-circle">
            <span class="prec 270"></span>
        </div>
  </div>
</div>
  <script>
	var isLoading=null;
	function startLoading() {
	  if (isLoading==null) {
		isLoading=setInterval(loopit,50,"c");
	  }
	}
	
	function checkLicenseApplied() {
        $.ajax({
                    url         : "/version.php",
                    cache       : false,
                    contentType : false,
                    processData : false,
                    dataType    : "json",
                    success     : function(data, textStatus, jqXHR) {
                    	if (data.hasOwnProperty("version") && data.hasOwnProperty("revision")) {
                    		location.href="/";
                    	}
                    }
               });
	}
    
    var progress=0;
    var activeBorder = $(".active-border");
    
	function loopit(dir){
		if (dir == "c")
		    progress++
		else
		    progress--;
		if (progress < 0)
		    progress += 360;
		if (progress >= 360)
		    progress -= 360;
		
		if (progress<=180) {
		    activeBorder.css("background-image","linear-gradient(" + (90+progress) + "deg, transparent 50%, #A2ECFB 50%),linear-gradient(90deg, #A2ECFB 50%, transparent 50%)");
		} else {
		    activeBorder.css("background-image","linear-gradient(" + (progress-90) + "deg, transparent 50%, #39B4CC 50%),linear-gradient(90deg, #A2ECFB 50%, transparent 50%)");
		}
		
		
		if (progress%100==0) {
			checkLicenseApplied();
		}
	}
	
	startLoading();
  </script>');
	}
}
echo('</body>
</html>');



