#!/usr/bin/php
<?php
 function getDefaultIntf() { return array("rx"=>0,"tx"=>0,"rx_bw_bytes"=>0,"rx_bw_kbit"=>0,"tx_bw_bytes"=>0,"tx_bw_kbit"=>0,"time"=>0); } function settings_load() { static $settingsf; if (!is_array($settingsf)) { $settings_dir=getsettingsdir(); $settings_file=$settings_dir."/settings.json"; $settings_def_json='{}'; $settings_json= file_exists($settings_file) ? file_get_contents($settings_file) : $settings_def_json; $settingsf=json_decode($settings_json,true); if (is_null($settingsf)) { $settingsf = json_decode($settingsf_def_json,true); } if (!array_key_exists("player",$settingsf)) { $settingsf["player"]=array(); } } return $settingsf; } function getSpoolDir() { static $spool_dir; if ($spool_dir==null) { $settingsf=settings_load(); $spool_dir=array_key_exists("spool_dir",$settingsf) && !empty(trim($settingsf["spool_dir"])) ? $settingsf["spool_dir"] : "/opt/nginx-dvss/spool"; } return $spool_dir; } function getsettingsdir() { return "/opt/nginx-dvss/settings/rtmp"; } function getchannelsdir() { $channelsdir=getsettingsdir()."/channels"; return $channelsdir; } function extractNumber($str) { preg_match('/^(-?[\d]+)(\.[\d]+)?/', $str, $match); $number=array_key_exists(0,$match) ? $match[0] : ""; return floatval($number); } function findFileInPaths($file,$paths=null) { if (file_exists($file)) return $file; if ($paths==null) $paths=explode(":",getenv("PATH")); foreach($paths as $path) { $fpath=sprintf("%s/%s",$path,$file); if (file_exists($fpath)) { return $fpath; } } return $file; } class publishTask { public $publishFile; public $pipes=array(); public $handle; public $status; public $lastReadTime; public $timeout; public $stdout_pipe; public $stderr_pipe; public $deleteFile=true; public $close_elapsed; function __construct($file,$sudo=true,$delete=true,$timeout=0) { $this->publishFile=$file; $this->deleteFile=$delete; $this->close_elapsed=0; $descriptorspec = array( 0 => array("pipe", "r"), 1 => array("pty" , "w"), 2 => array("pipe", "w") ); $quoteChar=""; $paramPos=0; if ($sudo) { $file="sudo -u www-data -H ".$file; } $lastPos=0; $lastDelimiter=" "; $lastChar=""; preg_match_all('#(?<!\\\\)("|\')(?<escaped>(?:[^\\\\]|\\\\.)*?)\1|(?<unescaped>\S+)#s', $file, $matches, PREG_SET_ORDER); $args = array(); $mnum=0; foreach($matches as $array){ $arg = !empty($array['escaped']) ? $array['escaped'] : $array['unescaped']; if ($mnum==0) { $cmdPath = findFileInPaths($arg); } else { $args[] = $arg; } $mnum++; } $this->stdout_pipe=tempnam(sys_get_temp_dir(),"dvs-watchdog-"); $this->stderr_pipe=tempnam(sys_get_temp_dir(),"dvs-watchdog-"); if (file_exists($this->stdout_pipe)) unlink($this->stdout_pipe); posix_mkfifo($this->stdout_pipe,0644); if (file_exists($this->stderr_pipe)) unlink($this->stderr_pipe); posix_mkfifo($this->stderr_pipe,0644); $pid = pcntl_fork(); if (-1 === $pid) { echo 'Failure on pcntl_fork'; } if ($pid) { $this->handle=$pid; $this->pipes[0]=null; $this->pipes[1]=fopen($this->stdout_pipe, "rb"); $this->pipes[2]=fopen($this->stderr_pipe, "rb"); stream_set_blocking($this->pipes[1], false); stream_set_blocking($this->pipes[2], false); if ($this->handle>0) { posix_setpgid($this->handle, $this->handle); } } else { fclose(STDIN); fclose(STDERR); $new_stdin=fopen($this->stdout_pipe, "wb"); $new_stderr=fopen($this->stderr_pipe, "wb"); fprintf($new_stdin,"file=%s,cmdPath=%s,stdout_pipe=%s,stderr_pipe=%s\n",$file,$cmdPath,$this->stdout_pipe,$this->stderr_pipe); fprintf($new_stderr,"Now launching - %s\n",$file); stream_set_blocking($new_stdin, false); stream_set_blocking($new_stderr, false); pcntl_exec($cmdPath,$args); } $this->timeout=$timeout; $this->lastReadTime=microtime(true); } function isRunning() { { $oread=fread($this->pipes[1],1024); if ($oread!="") $oread .= "\n"; $eread=fread($this->pipes[2],1024); if ($eread!="") $eread .= "\n"; if ($oread!="" || $eread!="") { $this->lastReadTime=microtime(true); echo $oread.$eread; } } $status=0; $is_running = $this->handle>0 && ( $this->checkPid() || ( pcntl_waitpid(-1*$this->handle,$status,WNOHANG) == 0 ) ); $timeDiff=$this->timeout > 0 ? microtime(true) - $this->lastReadTime : 0.0; if ( ( $timeDiff > $this->timeout ) || (!$is_running && $this->handle!=null) ) { if ( $timeDiff > $this->timeout ) { printf("timeDiff/%f - %f = %f > %f\n",microtime(true),$this->lastReadTime,$timeDiff,$this->timeout); } if ($this->closeTask()) $is_running=false; } return $is_running; } function checkPid() { if ($this->handle>0) { $proc_pid_dir=sprintf("/proc/%s",$this->handle); clearstatcache($proc_pid_dir); if (is_dir($proc_pid_dir) || file_exists($proc_pid_dir)) { return true; } } return false; } function closeTask() { if ($this->handle>0) { printf("Sending SIGINT signal to task with PID %d\n",$this->handle); posix_kill($this->handle, SIGINT); $this->close_elapsed += 0.1; usleep(100*1000); } if ($this->checkPid() && $this->handle>0 && $this->close_elapsed>=15) { printf("Sending SIGKILL signal to task with PID %d\n",$this->handle); posix_kill($this->handle, SIGKILL); usleep(500*1000); } if (!$this->checkPid()) { printf("Terminated process '%s' %s\n",$this->publishFile,$this->deleteFile ? '& deleting file' : ""); if ($this->deleteFile) unlink($this->publishFile); $this->handle=null; if (file_exists($this->stdout_pipe)) unlink($this->stdout_pipe); if (file_exists($this->stderr_pipe)) unlink($this->stderr_pipe); return true; } else { printf("Failed to Terminate process '%s' with PID %d , will try again\n",$this->publishFile,$this->handle); system(sprintf("ls /proc/%s",$this->handle)); return false; } } } class systemStats { static function GetCoreInformation() { $data = file('/proc/stat'); $cores = array(); foreach( $data as $line ) { if( preg_match('/^cpu[0-9]/', $line) ) { $info = explode(' ', $line ); $cores[] = array( 'user' => $info[1], 'nice' => $info[2], 'sys' => $info[3], 'idle' => $info[4], 'iowait' => $info[5] ); } } return $cores; } static function GetCpuPercentages($stats) { $cpus = array(); $cumul_cpu=0; $dif = array("user"=>0,"nice"=>0,"sys"=>0,"idle"=>0); for( $c = 0; $c<count($stats); $c++) { if ($c==0) { $lastStat=$stats[$c]; } else { for( $i = 0, $l = count($stats[$c]); $i < $l; $i++) { $dif['user'] = $stats[$c][$i]['user'] - $lastStat[$i]['user']; $dif['nice'] = $stats[$c][$i]['nice'] - $lastStat[$i]['nice']; $dif['sys'] = $stats[$c][$i]['sys'] - $lastStat[$i]['sys']; $dif['idle'] = $stats[$c][$i]['idle'] - $lastStat[$i]['idle']; $dif['iowait'] = $stats[$c][$i]['iowait'] - $lastStat[$i]['iowait']; $diff_idle = $stats[$c][$i]['idle'] - $lastStat[$i]['idle']; $cpu = array(); $total_cpu = array_sum($dif)==0 ? 1 : array_sum($dif); $cumul_cpu += round( ( $total_cpu - $diff_idle) / $total_cpu * 100, 1); } $lastStat=$stats[$c]; } } $numCpus=count($stats[0]); $cpus['max']=100; if ($cumul_cpu<0) { $cumul_cpu=0; } $cpus['total']=$cumul_cpu/( (count($stats) - 1) * $numCpus ); return $cpus; } static function getCpuStats($delayMs=90,$iterations=10) { $stats=array(); for($i=0; $i<$iterations; $i++) { $stats[] = self::GetCoreInformation(); usleep($delayMs*1000); } $data = self::GetCpuPercentages($stats); return $data; } static function getSystemMemInfo() { $data = explode("\n", file_get_contents("/proc/meminfo")); $meminfo = array(); foreach ($data as $line) { $lineArr=explode(":", $line); if (count($lineArr)>=2) { $key = $lineArr[0]; $val = $lineArr[1]; $meminfo[$key] = extractNumber(trim($val))*1024; } } return $meminfo; } static function getDiskInfo() { $free=disk_free_space(getSpoolDir()); $total=disk_total_space(getSpoolDir()); $info=array("free_mb" => round($free/1024/1024), "free" => $free, "total_mb" => round($total/1024/1024), "total" => $total); return $info; } } function generateIntfJson(&$interfaces,$lastInterf) { $interf=getDefaultIntf(); $interf["time"]=microtime(true); $timediff=$interf["time"]-$lastInterf["time"]; foreach ($interfaces as $intf) { $rxFile=sprintf("%s/statistics/rx_bytes",$intf); $rxBytes=file($rxFile,FILE_IGNORE_NEW_LINES)[0]; $txFile=sprintf("%s/statistics/tx_bytes",$intf); $txBytes=file($txFile,FILE_IGNORE_NEW_LINES)[0]; if ($rxBytes>$interf["rx"]) { $interf["rx"]=$rxBytes; $interf["tx"]=$txBytes; } } if ($timediff>0) { $interf["rx_bw_bytes"]=(int)round(max($interf["rx"]-$lastInterf["rx"],0)/$timediff); $interf["rx_bw_kbit"]=(int)round($interf["rx_bw_bytes"]*8.0/1024.0); $interf["tx_bw_bytes"]=(int)round(max($interf["tx"]-$lastInterf["tx"],0)/$timediff); $interf["tx_bw_kbit"]=(int)round($interf["tx_bw_bytes"]*8.0/1024.0); } $uptime=explode(" ",file("/proc/uptime",FILE_IGNORE_NEW_LINES)[0],2); $interf["uptime"]=(int)$uptime[0]; return $interf; } function recording_command($app,$stream,$command) { $http_cmd=sprintf("http://127.0.0.1:49235/rtmp_control/record/%s?app=%s&name=%s",$command,$app,$stream); $fhand=fopen($http_cmd, "r"); $content=stream_get_contents($fhand); fclose($fhand); fprintf(STDERR,"Sent %s command to %s\n",$command,$http_cmd); } function start_agent($reset=false) { $agent_running=array(); exec("pgrep dvss-agent",$agent_running); if (count($agent_running)>0) { system("pkill dvss-agent"); sleep(1); system("pkill -9 dvss-agent"); } system("/opt/nginx-dvss/sbin/dvss-agent"); } function channel_load($channel_id) { $channels_dir=getchannelsdir(); $channel_file=$channels_dir."/".$channel_id.".json"; $channel_def_json='{"channel_name":"new_channel",'. '"state":1}'; $channel_json= file_exists($channel_file) ? file_get_contents($channel_file) : $channel_def_json; $channelf=json_decode($channel_json,true); if (is_null($channelf)) { $channelf = json_decode($channel_def_json,true); } $channelf['id']=$channel_id; return $channelf; } function urls_load() { $urls_file = getsettingsdir()."/urls.json"; $urlsett = file_exists($urls_file) ? file_get_contents($urls_file) : "{}"; $urlsf = json_decode($urlsett,true); return $urlsf; } function getSchedulesDir() { $schedule_path=getSpoolDir()."/schedules"; return $schedule_path; } function &schedules_load() { $sched_dir = getSchedulesDir(); $sched_files = scandir(getSchedulesDir()); $sched_files = preg_grep('/\.json$/',$sched_files); $scheduleArr=array(); foreach($sched_files as $file) { $sched_file=$sched_dir."/".$file; $sch_json=file_get_contents($sched_file); $schedulef=json_decode($sch_json,true); if (is_array($schedulef)) { $repeat=array_key_exists("repeat",$schedulef) && !empty($schedulef["repeat"]) ? $schedulef["repeat"] : "off"; if ($repeat!="off" || !array_key_exists("state",$schedulef) || $schedulef["state"]=="started") $scheduleArr[$sched_file]=$schedulef; } } fprintf(STDERR,"scheduleArr=%s",var_export($scheduleArr,true)); return $scheduleArr; } function schedule_save(&$schedulef) { $schedule_file=sprintf("%s/%s.json",getSchedulesDir(),$schedulef["uuid"]); $sch_json=json_encode($schedulef); return file_put_contents($schedule_file,$sch_json); } function signal_abort($what=false) { static $abort; if ($what) $abort=true; if ($abort==null) $abort=false; return $abort; } $signal_handler=function($signo) { $signo=(int)$signo; printf("Received Signal #%d!\n",$signo); switch ($signo) { case SIGTERM: case SIGHUP: case SIGUSR1: case SIGINT: printf("Aborting program!\n"); signal_abort(true); break; default: } }; if ($argc>1 && $argv[1]=="--scheduler") { pcntl_signal(SIGTERM, $signal_handler); pcntl_signal(SIGHUP, $signal_handler); pcntl_signal(SIGUSR1, $signal_handler); pcntl_signal(SIGINT, $signal_handler); $pass=0; if (filesize("/etc/timezone")<40) { $timezone=file("/etc/timezone",FILE_IGNORE_NEW_LINES); date_default_timezone_set($timezone[0]); fprintf(STDERR,"date_default_timezone_set(%s);\n",$timezone[0]); } while (!signal_abort()) { pcntl_signal_dispatch(); if ( $pass % 150 == 0 ) { $scheduleArr=schedules_load(); } $ctime=time(); foreach($scheduleArr as $sched_file=>&$schedulef) { $repeat=array_key_exists("repeat",$schedulef) && !empty($schedulef["repeat"]) ? $schedulef["repeat"] : "off"; $last_action=array_key_exists("last_action",$schedulef) && !empty($schedulef["last_action"]) ? $schedulef["last_action"] : $ctime; $state=""; if ($repeat=="off" || $last_action>$ctime-(12*3600)) { $state= array_key_exists("state",$schedulef) ? $schedulef["state"] : ""; } if (!array_key_exists("record_start",$schedulef) || !array_key_exists("record_stop",$schedulef)) continue; $record=array(); foreach(array("start","stop") as $type) { $recField="record_".$type; $recTime=array_key_exists($recField,$schedulef) ? $schedulef[$recField] : ""; if ($recTime!="" && strlen($recTime)<10) { $dt=date("Y-m-d",$ctime)." ".$recTime; $dtime=new DateTime($dt); $record[$type]=$dtime->getTimestamp(); } else $record[$type]=strtotime($recTime); } $record_start = $record["start"]; $record_stop = $record["stop"]; if ($pass % 100 == 0) { fprintf(STDERR,"schedulef=%s,record_start=%s,record_stop=%s\n",var_export($schedulef,true),$record_start,$record_stop); } if ($repeat=="off" && $record_stop>$ctime+(24*3600*7) && file_exists($sched_file)) { unlink($sched_file); continue; } if ($repeat=="off" && $state!="started" && $state!="") continue; $stream=array_key_exists("stream",$schedulef) ? $schedulef["stream"] : ""; if ($state!="started") { if ($ctime>=$record_start-2 && $record_start<$ctime+30) { recording_command($schedulef["channel_name"],$stream,"start"); $schedulef["state"]="started"; $schedulef["last_action"]=$ctime; schedule_save($schedulef); } else if ($record_start<$ctime) { $schedulef["state"]="missed_start"; $schedulef["last_action"]=$ctime; schedule_save($schedulef); } } else if ($state=="started") { if ($ctime>=$record_stop-1 && $record_stop<$ctime+30) { recording_command($schedulef["channel_name"],$stream,"stop"); $schedulef["state"]="complete"; $schedulef["last_action"]=$ctime; schedule_save($schedulef); } else if ($record_stop<$ctime) { $schedulef["state"]="missed_stop"; $schedulef["last_action"]=$ctime; schedule_save($schedulef); } } } usleep(100*1000); $pass = ($pass+1) % 9000; } return 0; } $publishTask=null; $updaterTask=null; $interfaces=array(); $interf=getDefaultIntf(); if ($statsHandle = opendir('/sys/class/net')) { while (false !== ($intf = readdir($statsHandle))) { if ($intf!="." && $intf!=".." && $intf!="lo") { $intfDir=sprintf("/sys/class/net/%s",$intf); if (is_dir($intfDir)) { $interfaces[]=$intfDir; } } } } system('pkill -f "(ffmpeg|avconv|mjpeg_streamer).*(rtmp|http):\/\/"'); $pass=0; $lic_file="/opt/nginx-dvss/settings/license/dvss.lic"; $licenseStat=stat($lic_file); $urlWatchdog=array(); $urlsToDelete=array(); pcntl_signal(SIGCHLD, SIG_IGN); $scheduler_cmd=$argv[0]." --scheduler"; $schedulerTask=new publishTask($scheduler_cmd,false,false); $ssl_cert_file="/tmp/nginx_commands/ssl.crt"; $ssl_key_file="/tmp/nginx_commands/ssl.key"; while (1) { if ( $pass % 45 == 0 ) { system("dpkg -l nginx-dvss-webui | grep nginx-dvss-webui | awk '{print $3}' > /tmp/.version-nginx-dvss-webui ; chown www-data:www-data /tmp/.version-nginx-dvss-webui"); system("dpkg -l nginx-dvss       | grep nginx-dvss       | awk '{print $3}' > /tmp/.version-nginx-dvss ; chown www-data:www-data /tmp/.version-nginx-dvss"); system("dpkg -l hhvm       	     | grep hhvm             | awk '{print $3}' > /tmp/.version-nginx-hhvm ; chown www-data:www-data /tmp/.version-nginx-hhvm"); system("v4l2-ctl --list-devices > /tmp/nginx_commands/v4l2.txt"); } if (file_exists("/tmp/nginx_commands/commands.json")) { $commandsJson=file_get_contents("/tmp/nginx_commands/commands.json"); $commandsf=json_decode($commandsJson,true); printf("commandsJson=%s/commandsf=%s\n",$commandsJson,var_export($commandsf,true)); unlink("/tmp/nginx_commands/commands.json"); if ( !is_array($commandsf) || !array_key_exists("command",$commandsf) || $commandsf["command"]=="reload" ) { echo "Reloading nginx, configuration change detected ..."; system("/etc/init.d/nginx-dvss reload; /etc/init.d/nginx-dvss-rtmp restart"); } else if ( is_array($commandsf) && $commandsf["command"]=="restart" ) { echo "Restarting all services. Including myself .."; $script ="#!/bin/sh\n/etc/init.d/nginx-dvss stop\n/etc/init.d/nginx-dvss-rtmp stop\n/etc/init.d/nginx-dvss-webui stop\n"; $script.="/etc/init.d/nginx-dvss start\n/etc/init.d/nginx-dvss-rtmp start\n/etc/init.d/nginx-dvss-webui start\n"; $script_path="/tmp/nginx_commands/nginx_restart"; file_put_contents($script_path,$script); chmod($script_path,0775); system("nohup ".$script_path."&"); } } if (file_exists("/tmp/nginx_commands/mkdir.json")) { $mkdir_json=file_get_contents("/tmp/nginx_commands/mkdir.json"); $mkdirf=json_decode($mkdir_json,true); if ($mkdirf["command"]=="mkdir") { mkdir($mkdirf["dir"]); chown($mkdirf["dir"],"www-data"); chgrp($mkdirf["dir"],"www-data"); chmod($mkdirf["dir"],0775); } unlink("/tmp/nginx_commands/mkdir.json"); } if (file_exists($ssl_cert_file) || file_exists($ssl_key_file)) { $ssl_dir="/opt/nginx-dvss/conf/ssl"; if (!is_dir($ssl_dir)) { mkdir($ssl_dir,0700); } chmod($ssl_dir,0700); chown($ssl_dir,0); chgrp($ssl_dir,0); if (file_exists($ssl_cert_file)) { $ssl_cert_out=$ssl_dir."/ssl.crt"; rename($ssl_cert_file,$ssl_cert_out); chmod($ssl_cert_out,0600); chown($ssl_cert_out,0); chgrp($ssl_cert_out,0); } if (file_exists($ssl_key_file)) { $ssl_key_out=$ssl_dir."/ssl.key"; rename($ssl_key_file,$ssl_key_out); chmod($ssl_key_out,0600); chown($ssl_key_out,0); chgrp($ssl_key_out,0); } } if ( $updaterTask!=null && !$updaterTask->isRunning() ) { $updaterTask=null; } if (file_exists("/tmp/nginx_commands/updater.json") && $updaterTask==null) { $updaterf=json_decode(file_get_contents("/tmp/nginx_commands/updater.json"),true); if (is_array($updaterf)) { $update_script="#!/bin/sh\n"; $update_run=false; $update_file="/tmp/nginx_commands/updater.sh"; foreach($updaterf as $update) { if (array_key_exists("url",$update) && array_key_exists("filename",$update) && preg_match("/\.deb$/",$update["filename"])) { $update_script.=sprintf("wget %s -O %s && dpkg -i %s\n",escapeshellarg($update["url"]),escapeshellarg($update["filename"]),escapeshellarg($update["filename"])); $update_run=true; } } if ($update_run) { $update_script .= "dpkg --configure -a --force-confold --force-confmiss\napt-get install -f -y\ndpkg --configure -a --force-confold --force-confmiss\nrm /tmp/nginx_commands/updater.sh\n"; file_put_contents($update_file,$update_script); chmod($update_file,0775); $updaterTask=new publishTask("nohup ".$update_file,false,true); } } unlink("/tmp/nginx_commands/updater.json"); } if ( $publishTask!=null && !$publishTask->isRunning() ) { $publishTask=null; } if ( $publishTask==null) { $taskFiles=glob("/tmp/nginx_publish/*.sh"); if ( is_array($taskFiles) && count($taskFiles)>0 ) { $tfile=file_get_contents($taskFiles[0]); printf("\n\n%s\n\n",$tfile); printf("Creating publishTask for %s\n",$taskFiles[0]); chmod($taskFiles[0],0775); $publishTask=new publishTask($taskFiles[0],true); } } if ( $pass % 20 == 0 ) { $ffmpegUrls=urls_load(); } foreach($ffmpegUrls as $chan=>$chanf) { foreach(array("pull","push") as $url_type) { if (array_key_exists($url_type,$ffmpegUrls[$chan])) foreach($ffmpegUrls[$chan][$url_type] as $url=>$command) { if (!array_key_exists($chan,$urlWatchdog)) $urlWatchdog[$chan]=array("pull"=>array()); if (!array_key_exists($url,$urlWatchdog[$chan]["pull"])) { $urlWatchdog[$chan]["pull"][$url]=array("command" => $command, "task" => new publishTask($command,false,false,15.0), "type" => $url_type); } if (!is_object($urlWatchdog[$chan]["pull"][$url]["task"]) || !$urlWatchdog[$chan]["pull"][$url]["task"]->isRunning()) { $urlWatchdog[$chan]["pull"][$url]["task"]=null; unset($urlWatchdog[$chan]["pull"][$url]); } } } } $schedulerTask->isRunning(); $stopList=array(); $stop_files=glob("/tmp/nginx_commands/push_abort_*"); foreach($stop_files as $stop_file) { $stopArr=json_decode(file_get_contents($stop_file),true); if (array_key_exists("id",$stopArr)) { $stopList[]=$stopArr["id"]; unlink($stop_file); } } foreach($urlWatchdog as $chan=>$chanf) { foreach($urlWatchdog[$chan]["pull"] as $url=>&$taskArr) { $url_type=$taskArr["type"]; if ( !array_key_exists($chan,$ffmpegUrls) || !array_key_exists($url,$ffmpegUrls[$chan][$url_type]) || $ffmpegUrls[$chan][$url_type][$url]!=$taskArr["command"] || ( $url_type=="push" && in_array($chan,$stopList) ) ) { printf("chan=%s,url_type=%s,url=%s,Terminating urlWatchdog\n",$chan,$url_type,$url); if (is_object($taskArr["task"]) && $taskArr["task"]->isRunning()) { $taskArr["task"]->closeTask(); } if (!is_object($taskArr["task"]) || !$taskArr["task"]->checkPid()) { $taskArr["task"]=null; unset($ffmpegUrls[$chan]["pull"][$url]); } } else if (is_object($taskArr["task"])) $taskArr["task"]->isRunning(); } } $keyfile="/dev/shm/.dvss/.rawkey"; clearstatcache($lic_file); $licStat=stat($lic_file); $hhvm_running=array(); exec("pgrep hhvm",$hhvm_running); if ( (($pass % 5)==0 && ( (!file_exists($keyfile) || filesize($keyfile)<256) || ( is_array($licStat) && ( !is_array($licenseStat) || $licenseStat["mtime"]!=$licStat["mtime"] ) ) || count($hhvm_running)<=0 ) ) || ($pass==0) ) { $licenseStat=stat($lic_file); start_agent(true); } $sensors=array(); $sensors["cpu"]=\systemStats::getCpuStats(); $interf=generateIntfJson($interfaces,$interf); $sensors["interfaces"]=$interf; $sensors["memory"]=\systemStats::getSystemMemInfo(); $sensors["disk"]=\systemStats::getDiskInfo(); $sensorsJson=json_encode($sensors); file_put_contents("/tmp/sensors-interfaces.json",$sensorsJson); $pass = ($pass+1) % 900; } ?>
